#ifndef FTPD_H_
#define FTPD_H_
//--------------------------------------------------
#include "stm32f4xx_hal.h"
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <ctype.h>
#include "fatfs.h"
#include "w5500.h"
//--------------------------------------------------
#define HOSTNAME "w5500Chip"
#define VERSION "1.0"
//--------------------------------------------------
// FTP commands
enum ftp_cmd {
  USER_CMD,
  ACCT_CMD,
  PASS_CMD,
  TYPE_CMD,
  LIST_CMD,
  CWD_CMD,
  DELE_CMD,
  NAME_CMD,
  QUIT_CMD,
  RETR_CMD,
  STOR_CMD,
  PORT_CMD,
  NLST_CMD,
  PWD_CMD,
  XPWD_CMD,
  MKD_CMD,
  XMKD_CMD,
  XRMD_CMD,
  RMD_CMD,
  STRU_CMD,
  MODE_CMD,
  SYST_CMD,
  XMD5_CMD,
  XCWD_CMD,
  FEAT_CMD,
  PASV_CMD,
  SIZE_CMD,
  MLSD_CMD,
  APPE_CMD,
  NO_CMD,
};
//--------------------------------------------------
typedef struct ftp_prop {
  volatile uint8_t connect_stat;//    FTP
  volatile uint8_t connect_stat_data;//     FTP
  volatile uint8_t login_stat;//  FTP
  volatile uint8_t ftp_type;// Transfer type
  volatile uint8_t datasock_mode;//  
  volatile uint8_t datasock_state;//    
  volatile uint8_t data_stat;//  
  volatile uint16_t rem_bytes_dirinfo;//     
  volatile uint32_t rem_filesize;//   
  enum ftp_cmd current_cmd;
  char username[100];
  char work_dir[100];
  char filename[100];
  FIL my_fil;
} ftp_prop_ptr;
//--------------------------------------------------
#define FTP_DISCONNECT 0
#define FTP_CONNECT 1
//--------------------------------------------------
#define FTPS_NOT_LOGIN 0
#define FTPS_LOGIN 1
//--------------------------------------------------
#define ASCII_TYPE 0
#define IMAGE_TYPE 1
#define LOGICAL_TYPE 2
//--------------------------------------------------
#define DATASOCK_IDLE 0
#define DATASOCK_READY 1
#define DATASOCK_START 2
//--------------------------------------------------
#define PASSIVE_MODE 0
#define ACTIVE_MODE 1
//--------------------------------------------------
void ftp_receive(uint8_t sn);
//--------------------------------------------------
#endif /* FTPD_H_ */
