#include "ftpd.h"
//-----------------------------------------------
extern UART_HandleTypeDef huart2;
//-----------------------------------------------
extern char str1[60];
extern uint8_t sect[515];
static char buf1[256];
extern uint8_t ipaddr[4];
extern uint16_t local_port_ftp_data_passiv;
ftp_prop_ptr ftpprop;
extern volatile uint16_t tcp_size_wnd;
static FILINFO fileInfo;
static DIR dir;
extern uint32_t bytesread;
//------------------------------------------------
/* Command table */
static char *ftp_commands[] = {
"user",
"acct",
"pass",
"type",
"list",
"cwd",
"dele",
"name",
"quit",
"retr",
"stor",
"port",
"nlst",
"pwd",
"xpwd",
"mkd",
"xmkd",
"xrmd",
"rmd ",
"stru",
"mode",
"syst",
"xmd5",
"xcwd",
"feat",
"pasv",
"size",
"mlsd",
"appe",
NULL
};
//-----------------------------------------------
void tcp_send_ftp_one(uint8_t sn, uint8_t * buf, uint16_t len)
{
  uint16_t end_point;
  end_point = GetWritePointer(sn);
  end_point+=len;
  //     
  SetWritePointer(sn, end_point);
  end_point = GetWritePointer(sn);
  w5500_writeSockBuf(sn, end_point, buf, len);
  // 
  RecvSocket(sn);
  SendSocket(sn);
}
//-----------------------------------------------
void tcp_recv_ftp(uint8_t sn, uint8_t * buf, uint16_t len_buf)
{
  uint16_t len;
  uint16_t point;
  len = GetSizeRX(sn);
  point = GetReadPointer(sn);
  //  
  sprintf(str1,"S%d point RX:0x%04X\r\n",sn,point);
  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
  //   
  sprintf(str1,"S%d len buf:0x%04X\r\n",sn,len);
  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
  if(len>len_buf) len=len_buf;
  // 
  w5500_readSockBuf(sn, point, (uint8_t*) buf, len);
  // 
  SetReadPointer(sn, point+len);
  RecvSocket(sn);
}
//-----------------------------------------------
void ftp_login(uint8_t sn, char * pass)
{
  char buf_send[100];
  uint16_t len;
  data_sect_ptr *datasect = (void*)buf_send;
  len = sprintf((char*)datasect->data, "230 Logged on\r\n");
  tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
  ftpprop.login_stat = FTPS_LOGIN;
}
//-----------------------------------------------
void ftp_cmd_parse(uint8_t sn, char* buf)
{
  char **cmd_point, *ch, *arg, *ch_tmp;
  char buf_send[200];
  uint16_t len;
  uint16_t offset;
  data_sect_ptr *datasect = (void*)buf_send;
  //   
  for (ch = buf; *ch != ' ' && *ch != '\0'; ch++) *ch = tolower(*ch);
  //    
  for (cmd_point = ftp_commands; *cmd_point != NULL; cmd_point++)
  {
    if (strncmp(*cmd_point, buf, strlen(*cmd_point)) == 0) break;
  }
  if (*cmd_point == NULL)
  {
    sprintf((char*)datasect->data, "500 Unknown command '%s'\r\n", buf);
    tcp_send_ftp_one(sn, (uint8_t *)buf_send, strlen((char*)datasect->data));
    return;
  }
  if (ftpprop.login_stat == FTPS_NOT_LOGIN)
  {
	  switch(cmd_point - ftp_commands)
	    {
	      case USER_CMD:
	      case PASS_CMD:
	      case QUIT_CMD:
	        break;
	      default:
	        len = sprintf((char*)datasect->data, "530 Please log in with USER and PASS\r\n");
	        tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
	        return;
	    }
  	  }
	//     
	arg = &buf[strlen(*cmd_point)];
	while(*arg == ' ') arg++;
	switch (cmd_point - ftp_commands)
	{
		case USER_CMD:
			sprintf(str1, "USER_CMD : %s", arg);
			HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			//   
			len = strlen(arg);
			arg[len - 1] = 0x00;
			arg[len - 2] = 0x00;
			strcpy(ftpprop.username, arg);
			len = sprintf((char*)datasect->data, "331 Enter PASS command\r\n");
			tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
			break;
		case PASS_CMD :
		  len = strlen(arg);
		  arg[len - 1] = 0x00;
		  arg[len - 2] = 0x00;
		  ftp_login(sn, arg);
		  break;
		case SYST_CMD :
		  len = sprintf((char*)datasect->data, "215 UNIX emulated by W5500\r\n\r\n");
		  tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		  break;
		case FEAT_CMD :
		  len = sprintf((char*)datasect->data, "211-Features:\r\n MDTM\r\n REST STREAM\r\n SIZE\r\n MLST size*;type*;create*;modify*;\r\n MLSD\r\n UTF8\r\n CLNT\r\n MFMT\r\n211 END\r\n");
		  tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		  break;
		case CWD_CMD:
		  len = strlen(arg);
		  arg[len - 1] = 0x00;
		  arg[len - 2] = 0x00;
		  //  
		  if(arg[0]=='/')
		  {
		    strcpy(ftpprop.work_dir, arg);
		  }
		  //   
		  else if(strncmp(arg,"..", 2) == 0)
		  {
			  while(1)
			  {
			    ch_tmp = strchr(ftpprop.work_dir+offset,'/');
			    if(!ch_tmp)
			    {
			      ftpprop.work_dir[offset] = '\0';
			      break;
			    }
			    ch = ch_tmp;
			    offset = ch_tmp - ftpprop.work_dir + 1;
			  }
			  //  '/',  
			  len = strlen(ftpprop.work_dir);
			  if (len>1)
			  {
			    if(ftpprop.work_dir[len-1]=='/')
			    {
			      ftpprop.work_dir[len-1]=0;
			    }
			  }
		  }
		  else
		  {
		    //   '/'  ,   
		    len = strlen(ftpprop.work_dir);
		    if(ftpprop.work_dir[len-1]!='/') strcat(ftpprop.work_dir,"/");
		    strcat(ftpprop.work_dir, arg);
		  }
		  len = sprintf((char*)datasect->data, "250 CWD successful. \"%s\" is current directory.\r\n", ftpprop.work_dir);
		  tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		  break;
		case TYPE_CMD :
		  len = strlen(arg);
		  arg[len - 1] = 0x00;
		  arg[len - 2] = 0x00;
		  switch(arg[0])
		  {
		    case 'A':
		    case 'a': /* Ascii */
		      ftpprop.ftp_type = ASCII_TYPE;
		      len = sprintf((char*)datasect->data, "200 Type set to %s\r\n", arg);
		      tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		      break;
		    case 'B':
		    case 'b': /* Binary */
		    case 'I':
		    case 'i': /* Image */
		      ftpprop.ftp_type = IMAGE_TYPE;
		      len = sprintf((char*)datasect->data, "200 Type set to %s\r\n", arg);
		      tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		      break;
		    default: /* Invalid */
		      len = sprintf((char*)datasect->data, "501 Unknown type \"%s\"\r\n", arg);
		      tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		      break;
		  }
		  break;
		  case PASV_CMD:
		    local_port_ftp_data_passiv++;
		    if(local_port_ftp_data_passiv > 50000) local_port_ftp_data_passiv=35000;
		    len = sprintf((char*)datasect->data, "227 Entering Passive Mode (%d,%d,%d,%d,%d,%d)\r\n",
		      ipaddr[0], ipaddr[1], ipaddr[2], ipaddr[3], local_port_ftp_data_passiv >> 8, local_port_ftp_data_passiv & 0x00ff);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    //       
		    if(GetSocketStatus(FTP_SOCKET_DATA)==SOCK_ESTABLISHED)
		      DisconnectSocket(FTP_SOCKET_DATA); //
		    CloseSocket(FTP_SOCKET_DATA);
		    SocketClosedWait(FTP_SOCKET_DATA);
		    HAL_UART_Transmit(&huart2,(uint8_t*)"654321\r\n",8,0x1000);
		    sprintf(str1,"S%d closed\r\n",FTP_SOCKET_DATA);
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    SetSockPort(FTP_SOCKET_DATA, local_port_ftp_data_passiv);
		    OpenSocket(FTP_SOCKET_DATA,Mode_TCP);
		    //   ( SOCK_INIT)
		    SocketInitWait(FTP_SOCKET_DATA);
		    //  
		    ListenSocket(FTP_SOCKET_DATA);
		    SocketListenWait(FTP_SOCKET_DATA);
		    ftpprop.datasock_mode = PASSIVE_MODE;
		    ftpprop.datasock_state = DATASOCK_READY;
		    sprintf(str1,"PASV port: %d\r\n", local_port_ftp_data_passiv);
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    break;
		  case MLSD_CMD:
		    len = sprintf((char*)datasect->data, "150 Opening data channel for directory listing of \"%s\"\r\n", ftpprop.work_dir);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    ftpprop.current_cmd = MLSD_CMD;
		    break;
		  case LIST_CMD:
		    sprintf(str1,"LIST_CMD\r\n");
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    len = sprintf((char*)datasect->data, "150 Opening data channel for directory listing of \"%s\"\r\n", ftpprop.work_dir);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    ftpprop.current_cmd = LIST_CMD;
		    break;
		  case PWD_CMD:
		  case XPWD_CMD:
		    len = sprintf((char*)datasect->data, "257 \"%s\" is current directory.\r\n", ftpprop.work_dir);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    break;
		  case MKD_CMD:
		  case XMKD_CMD:
		    len = strlen(arg);
		    arg[len - 1] = 0x00;
		    arg[len - 2] = 0x00;
		    sprintf(str1,"MKD_CMD\r\n");
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    //      
		    strcpy(buf1,ftpprop.work_dir);
		    len = strlen(buf1);
		    if(buf1[len-1]!='/') strcat(buf1,"/");
		    strcat(buf1,arg);
		    if (f_mkdir(buf1) != 0)
		    {
		      len = sprintf((char*)datasect->data, "550 Can't create directory. \"%s\"\r\n", arg);
		    }
		    else
		    {
		      len = sprintf((char*)datasect->data, "257 MKD command successful. \"%s\"\r\n", arg);
		    }
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    break;
		  case DELE_CMD:
		    len = strlen(arg);
		    arg[len - 1] = 0x00;
		    arg[len - 2] = 0x00;
		    sprintf(str1,"DELE_CMD\r\n");
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    if (f_unlink(arg) != 0)
		    {
		      len = sprintf((char*)datasect->data, "550 Could not delete. \"%s\"\r\n", arg);
		    }
		    else
		    {
		      len = sprintf((char*)datasect->data, "250 Deleted. \"%s\"\r\n", arg);
		    }
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    break;
		  case RETR_CMD:
		    len = strlen(arg);
		    arg[len - 1] = 0x00;
		    arg[len - 2] = 0x00;
		    sprintf(str1,"RETR_CMD\r\n");
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    if(strlen(ftpprop.work_dir) == 1)
		      sprintf(ftpprop.filename, "/%s", arg);
		    else
		      sprintf(ftpprop.filename, "%s/%s", ftpprop.work_dir, arg);
		    len = sprintf((char*)datasect->data, "150 Opening data channel for file downloand from server of \"%s\"\r\n",
		    ftpprop.filename);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    ftpprop.current_cmd = RETR_CMD;
		    break;
		  case STOR_CMD:
		    len = strlen(arg);
		    arg[len - 1] = 0x00;
		    arg[len - 2] = 0x00;
		    sprintf(str1,"STOR_CMD\r\n");
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    if(strlen(ftpprop.work_dir) == 1)
		      sprintf(ftpprop.filename, "/%s", arg);
		    else
		      sprintf(ftpprop.filename, "%s/%s", ftpprop.work_dir, arg);
		    len = sprintf((char*)datasect->data, "150 Opening data channel for file upload to server of \"%s\"\r\n",
		      ftpprop.filename);
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    ftpprop.current_cmd = STOR_CMD;
		    break;
		  case QUIT_CMD :
		    len = sprintf((char*)datasect->data, "221 Goodbye!\r\n");
		    tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
		    DisconnectSocket(sn); //
		    SocketClosedWait(sn);
		    sprintf(str1,"S%d closed\r\n",sn);
		    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
		    OpenSocket(sn,Mode_TCP);
		    //   ( SOCK_INIT)
		    SocketInitWait(sn);
		    //  
		    ListenSocket(sn);
		    SocketListenWait(sn);
		    ftpprop.connect_stat = FTP_DISCONNECT;
		    break;
		default: // Invalid
			len =sprintf((char*)datasect->data, "500 Unknown command '%s'\r\n", arg);
			tcp_send_ftp_one(sn, (uint8_t *)buf_send, len);
			HAL_Delay(1000);
			DisconnectSocket(sn); //
			SocketClosedWait(sn);
			sprintf(str1,"S%d closed\r\n",sn);
			HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			OpenSocket(sn,Mode_TCP);
			//   ( SOCK_INIT)
			SocketInitWait(sn);
			//  
			ListenSocket(sn);
			SocketListenWait(sn);
			break;
	}

}
//-----------------------------------------------
//     
void ftp_send_dirinfo(uint8_t sn, char *buf)
{
  FRESULT res; // 
  uint16_t len;
  char str_date[15];
  int str_date_ptr = 0, buf_ptr = 0;
  uint16_t buf1_ptr = 0;
  char *fn;
  fileInfo.lfname = (char*)sect;
  fileInfo.lfsize = sizeof(sect);
  static char buf1[256];
  buf_ptr+=3;//     
  //       ,   
  if(ftpprop.rem_bytes_dirinfo)
  {
    memcpy((uint8_t*)(buf+buf_ptr),(uint8_t*)(buf1+strlen(buf1)-ftpprop.rem_bytes_dirinfo),ftpprop.rem_bytes_dirinfo);
    buf_ptr+=ftpprop.rem_bytes_dirinfo;
  }
  while(1)
  {
    buf1_ptr = 0;
    res = f_readdir(&dir, &fileInfo);
    if (res==FR_OK && fileInfo.fname[0])
    {
      fn = fileInfo.lfname;
      if(!strlen(fn)) fn=fileInfo.fname;
    }
    else
    {
      break;
    }
    switch((fileInfo.fdate >> 5) & 0x0f)
    {
      case 1:
        len = sprintf(str_date, "JAN ");
        break;
      case 2:
        len = sprintf(str_date, "FEB ");
        break;
      case 3:
        len = sprintf(str_date, "MAR ");
        break;
      case 4:
        len = sprintf(str_date, "APR ");
        break;
      case 5:
        len = sprintf(str_date, "MAY ");
        break;
      case 6:
        len = sprintf(str_date, "JUN ");
        break;
      case 7:
        len = sprintf(str_date, "JUL ");
        break;
      case 8:
        len = sprintf(str_date, "AUG ");
        break;
      case 9:
        len = sprintf(str_date, "SEP ");
        break;
      case 10:
        len = sprintf(str_date, "OCT ");
        break;
      case 11:
        len = sprintf(str_date, "NOV ");
        break;
      case 12:
        len = sprintf(str_date, "DEC ");
        break;
    }
    str_date_ptr += len;
    len = sprintf(str_date + str_date_ptr, "%d ", (fileInfo.fdate & 0x1f));
    str_date_ptr += len;
    len = sprintf(str_date + str_date_ptr, "%d", (((fileInfo.fdate >> 9) & 0x7f) + 1980));
    str_date_ptr = 0;
    if(fileInfo.fattrib & AM_DIR)
    {
      sprintf(buf1, "d");
    }
    else
    {
      sprintf(buf1, "-");
    }
    buf1_ptr++;
    len = sprintf(buf1 + buf1_ptr, "rwxr-xr-x 1 ftp ftp %lu %s %s\r\n", fileInfo.fsize, str_date, fn);
    buf1_ptr += len;
    if((buf_ptr+buf1_ptr)>(SIZE_WND+3))
    {
      memcpy((uint8_t*)(buf+buf_ptr),(uint8_t*)buf1,SIZE_WND+3-buf_ptr);
    }
    else
    {
      memcpy((uint8_t*)(buf+buf_ptr),(uint8_t*)buf1,buf1_ptr);
    }
    buf_ptr += buf1_ptr;
    if(buf_ptr>(SIZE_WND+3))
    {
      ftpprop.rem_bytes_dirinfo = buf_ptr-SIZE_WND-3;
      ftpprop.data_stat=DATA_MIDDLE;
      break;
    }
    else
    {
      ftpprop.rem_bytes_dirinfo = 0;
    }
  }
	if(buf_ptr>(SIZE_WND+3))
	{
	  buf_ptr=SIZE_WND+3;
	}
	else
	{
	  ftpprop.data_stat=DATA_END;
	  f_closedir(&dir);
	}
	tcp_send_ftp_one(sn, (uint8_t *)buf, buf_ptr-3);//     
}
//-----------------------------------------------
//     ( )
void ftp_send_file(uint8_t sn, char *buf)
{
  uint32_t buf_ptr = 0;
  buf_ptr+=3;//     
  uint32_t lensect = 0;
  while(1)
  {
    //f_lseek(&ftpprop.my_fil,ftpprop.my_fil.fsize-ftpprop.rem_filesize); //    
    lensect = 512;
    //  ,  
    if(ftpprop.rem_filesize<=512)
    {
      lensect = ftpprop.rem_filesize;
    }
    // ,   ,     
    if(lensect>(SIZE_WND+3-buf_ptr))
    {
      lensect = SIZE_WND+3-buf_ptr;
    }
    f_read(&ftpprop.my_fil,buf+buf_ptr,lensect,(UINT *)&bytesread);
    ftpprop.rem_filesize -= lensect;
    buf_ptr+=lensect;
    if(ftpprop.rem_filesize<=0)
    {
      ftpprop.data_stat=DATA_END;
      HAL_UART_Transmit(&huart2,(uint8_t*)"FILE Close\r\n",12,0x1000);
      f_close(&ftpprop.my_fil);
      break;
    }
    if((SIZE_WND+3-buf_ptr)<=0)
    {
      ftpprop.data_stat=DATA_MIDDLE;
      break;
    }
  }
  tcp_send_ftp_one(sn, (uint8_t *)buf, buf_ptr-3);//     
}
//-----------------------------------------------
void ftp_data_send(uint8_t sn)
{
	  static char buf_send[SIZE_WND+3];
	  FRESULT res; // 
	  buf_send[0] = '\0';
	  switch(ftpprop.current_cmd)
	  {
	    case LIST_CMD:
	    case MLSD_CMD:
			fileInfo.lfname = (char*)sect;
			fileInfo.lfsize = sizeof(sect);
			if(ftpprop.data_stat==DATA_FIRST)
			{
			  res = f_opendir(&dir, ftpprop.work_dir);
			  if(res == FR_OK)
			  {
			    ftp_send_dirinfo(sn,buf_send);
			    if(ftpprop.data_stat==DATA_END)
			    {
			      f_closedir(&dir);
			    }
			  }
			}
			else if(ftpprop.data_stat==DATA_MIDDLE)
			{
			  ftp_send_dirinfo(sn,buf_send);
			}
	    	break;
	    case RETR_CMD:
		  if(ftpprop.data_stat==DATA_FIRST)
		  {
			res = f_open(&ftpprop.my_fil, (const char *)ftpprop.filename, FA_READ);
			sprintf(str1,"f_open: %d\r\n",res);
			HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			sprintf(str1,"f_size: %lu\r\n",ftpprop.my_fil.fsize);
			HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			if(res == FR_OK)
			{
			  ftpprop.rem_filesize = ftpprop.my_fil.fsize;
			  ftp_send_file(sn,buf_send);
			}
		  }
		  else if(ftpprop.data_stat==DATA_MIDDLE)
		  {
		    ftp_send_file(sn,buf_send);
		  }
	      break;
	    default:
	    	break;
	  }
}
//-----------------------------------------------
void ftp_data_receive(uint8_t sn)
{
  uint16_t len;
  uint16_t point;
  static char buf_recv[SIZE_WND+1];
  uint16_t len_full=0;
  FRESULT res; // 
  if(ftpprop.data_stat==DATA_FIRST)
  {
    res = f_open(&ftpprop.my_fil, (const char *)ftpprop.filename, FA_CREATE_ALWAYS | FA_WRITE);
    if(res != FR_OK) return;
  }
  while(1)
  {
	  len = GetSizeRX(sn);
	  point = GetReadPointer(sn);
	  //  
	  sprintf(str1,"S%d point RX:0x%04X\r\n",sn,point);
	  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	  //   
	  sprintf(str1,"S%d len buf:0x%04X\r\n",sn,len);
	  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	  if(len<=0)
	  {
	    f_close(&ftpprop.my_fil);
	    break;
	  }
	  tcp_recv_ftp(sn,(uint8_t*)buf_recv,len);
	  f_write(&ftpprop.my_fil,buf_recv,len,(UINT *)&bytesread);
	  len_full+=len;
	  //   
	  sprintf(str1,"S%d len_full buf:0x%04X\r\n",sn,len_full);
	  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	  point = GetReadPointer(sn);
	  //  
	  sprintf(str1,"1 S%d point RX:0x%04X\r\n",sn,point);
	  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	  len = GetSizeRX(sn);
	  //   
	  sprintf(str1,"1 S%d len buf:0x%04X\r\n",sn,len);
	  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	  if(GetSocketStatus(sn)!=SOCK_ESTABLISHED)
	  {
	    //    ,       
	    tcp_recv_ftp(sn,(uint8_t*)buf_recv,len);
	    f_write(&ftpprop.my_fil,buf_recv,len,(UINT *)&bytesread);
	    f_close(&ftpprop.my_fil);
	    break;
	  }
  }
  ftpprop.current_cmd = NO_CMD;
  ftpprop.data_stat=DATA_COMPLETED;
  DisconnectSocket(FTP_SOCKET_DATA); //
  SocketClosedWait(FTP_SOCKET_DATA);
  sprintf(str1,"S%d closed\r\n",FTP_SOCKET_DATA);
  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
  OpenSocket(FTP_SOCKET_DATA,Mode_TCP);
  //   ( SOCK_INIT)
  SocketInitWait(FTP_SOCKET_DATA);
  //  
  ListenSocket(FTP_SOCKET_DATA);
  SocketListenWait(FTP_SOCKET_DATA);
  ftpprop.connect_stat_data = 0;
  len = sprintf((char *)(sect+3), "226 Successfully transferred \"%s\"\r\n", ftpprop.work_dir);
  tcp_send_ftp_one(FTP_SOCKET_CTRL, sect, len);
}
//-----------------------------------------------
void ftp_receive(uint8_t sn)
{
  uint16_t len;
  uint16_t point;
  len = GetSizeRX(sn);
  if(sn == FTP_SOCKET_CTRL)
  {
	  data_sect_ptr *datasect = (void*)sect;
	  if(!ftpprop.connect_stat)
	  {
		  strcpy(ftpprop.work_dir, "/");
		  sprintf((char*)datasect->data, "220 %s FTP version %s ready.\r\n", HOSTNAME, VERSION);
		  tcp_send_ftp_one(sn, (uint8_t *)sect, strlen((char*)datasect->data));
		  ftpprop.connect_stat = FTP_CONNECT;
	  }
	  else
	  {
		  //,    
		  if(len > 0)
		  {
			  //   
			  sprintf(str1,"S%d len buf:0x%04X\r\n",sn,len);
			  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			  // 
			  point = GetReadPointer(sn);
			  //  
			  sprintf(str1,"S%d point RX:0x%04X\r\n",sn,point);
			  HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
			  w5500_readSockBuf(sn, point, sect, len);
			  // 
			  SetReadPointer(sn, point+len);
			  RecvSocket(sn);
			  // 
			  sect[len] = 0;
			  //    
			  sprintf(str1,"S%d: %s\r\n", sn, (char*)sect);
			  HAL_UART_Transmit(&huart2,(uint8_t*)(char*)sect,strlen((char*)sect),0x1000);
			  ftp_cmd_parse(sn, (char*)sect);
		  }
	  }
  }
  else if(sn == FTP_SOCKET_DATA)
  {
	  if(!ftpprop.connect_stat_data)
	  {
	    sprintf(str1,"FTP Data socket Connected\r\n");
	    HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	    ftpprop.connect_stat_data = 1;
	  }
	  switch(ftpprop.data_stat)
	  {
	    case DATA_END:
	      ftpprop.current_cmd = NO_CMD;
	      len = sprintf((char *)(sect+3), "226 Successfully transferred \"%s\"\r\n", ftpprop.work_dir);
	      tcp_send_ftp_one(FTP_SOCKET_CTRL, sect, len);
	      ftpprop.data_stat=DATA_COMPLETED;
	      DisconnectSocket(FTP_SOCKET_DATA); //
	      SocketClosedWait(FTP_SOCKET_DATA);
	      sprintf(str1,"S%d closed\r\n",FTP_SOCKET_DATA);
	      HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	      OpenSocket(FTP_SOCKET_DATA,Mode_TCP);
	      //   ( SOCK_INIT)
	      SocketInitWait(FTP_SOCKET_DATA);
	      //  
	      ListenSocket(FTP_SOCKET_DATA);
	      SocketListenWait(FTP_SOCKET_DATA);
	      ftpprop.connect_stat_data = 0;
	      break;
	    case DATA_MIDDLE:
	      ftp_data_send(sn);
	      break;
	    case DATA_STOR_MIDDLE:
	      ftp_data_receive(sn);
	      break;
	  }
	    switch(ftpprop.current_cmd)
	    {
	      case LIST_CMD:
	      case MLSD_CMD:
	      case RETR_CMD:
	        if(ftpprop.data_stat==DATA_COMPLETED)
	        {
	          ftpprop.data_stat=DATA_FIRST;
	          ftp_data_send(sn);
	        }
	        break;
	      case STOR_CMD:
	        if(ftpprop.data_stat==DATA_COMPLETED)
	        {
	          ftpprop.data_stat=DATA_FIRST;
	        }
	        else if(ftpprop.data_stat==DATA_FIRST)
	        {
	          if(len>0)
	          {
	            point = GetReadPointer(sn);
	            //  
	            sprintf(str1,"S%d point RX:0x%04X\r\n",sn,point);
	            HAL_UART_Transmit(&huart2,(uint8_t*)str1,strlen(str1),0x1000);
	            ftp_data_receive(sn);
	          }
	        }
	        break;
	      default:
	        break;
	    }
  }
}
//-----------------------------------------------
